require 'kconv'
require 'yaml'
require 'net/http'
require 'Win32API'
require 'win32/clipboard'
include Win32

recruit_file = 'battle_support.yaml'

# 設定ファイル読み込み
recruit = YAML.load_file(recruit_file)

# 例外回避（Tenco!のまねっこ）
recruit ||= {}
recruit['access'] ||= {}
recruit['battle_num'] ||= {}
recruit['weather'] ||= {}
recruit['character'] ||= {}
recruit['etc'] ||= {}
recruit['sim_app1'] ||= {}
recruit['sim_app2'] ||= {}
recruit['sim_app3'] ||= {}

# 募集文設定値読み込み
ip = recruit['access']['ip'] || ''
port = recruit['access']['port'] || ''
battle_num = recruit['battle_num'].to_s || ''
weather = recruit['weather'] || ''
character = recruit['character'] || ''
etc = recruit['etc'] || ''
template = recruit['template'] || ''
sim_app1 = recruit['sim_app1']
sim_app2 = recruit['sim_app2']
sim_app3 = recruit['sim_app3']

# メソッド定義
def startApp( app )
  app_name = app.split(/\//)[-1]
  if app_name == 'hikouseki.exe' then
    get_hikouseki_path= Win32API.new("battle_support.dll", "getHikousekiPath", %w(p i), "i")
    hoge = "\0" * 1024
    ret = get_hikouseki_path.call(hoge, 1024)
    return if ret != 0 
  end
  Thread.start {
    system(app)
  }
end

# メイン処理
file = open(template.kconv(Kconv::SJIS, Kconv::UTF8))
write_sentence = file.read
file.close
write_sentence.gsub!(/\n/, "\r\n")
#File::open(template.kconv(Kconv::SJIS, Kconv::UTF8)) {|f|
#  f.each {|line| write_sentence.concat(line)}
#}

# IPアドレス取得
http = Net::HTTP.new('www5.famille.ne.jp', 80)
http_req = Net::HTTP::Get.new('/~hakuu/ipaddr.cgi')
http_res = http.request(http_req)

if /(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/ =~ http_res.body.to_s
  ip = $1
end

write_sentence.gsub!(/<access>/, ip.kconv(Kconv::SJIS, Kconv::UTF8) + ':' + port)
write_sentence.gsub!(/<battle_num>/, battle_num.kconv(Kconv::SJIS, Kconv::UTF8))
write_sentence.gsub!(/<weather>/, weather.kconv(Kconv::SJIS, Kconv::UTF8))
write_sentence.gsub!(/<character>/, character.kconv(Kconv::SJIS, Kconv::UTF8))
write_sentence.gsub!(/<etc>/, etc.kconv(Kconv::SJIS, Kconv::UTF8))

puts write_sentence

Clipboard.set_data(write_sentence)

sleep 1

# 登録アプリ起動
startApp( sim_app1 )
startApp( sim_app2 )
startApp( sim_app3 )
