require 'tk'
require 'kconv'
require 'yaml'

# to_yamlの日本語対応
# 引用元：半隠遁日記
# http://d.hatena.ne.jp/Rommy/20061229/1167406811
class String
  def is_binary_data?
    false
  end

  def decode
    gsub(/\\x(\w{2})/){[Regexp.last_match.captures.first.to_i(16)].pack("C")}
  end
end

ObjectSpace.each_object(Class){|klass|
  klass.class_eval{
    if method_defined?(:to_yaml) && !method_defined?(:to_yaml_with_decode)
      def to_yaml_with_decode(*args)
        result = to_yaml_without_decode(*args)
        if result.kind_of? String
          result.decode
        else
          result
        end
      end
      alias_method :to_yaml_without_decode, :to_yaml
      alias_method :to_yaml, :to_yaml_with_decode
    end
  }
}

recruit_file = 'battle_support.yaml'

# 設定ファイル読み込み
recruit = YAML.load_file(recruit_file)

# 例外回避（Tenco!のまねっこ）
recruit ||= {}
recruit['access'] ||= {}
recruit['battle_num'] ||= {}
recruit['weather'] ||= {}
recruit['character'] ||= {}
recruit['etc'] ||= {}
recruit['sim_app1'] ||= {}
recruit['sim_app2'] ||= {}
recruit['sim_app3'] ||= {}

# 募集文設定値読み込み
#ip = recruit['access']['ip'] || ''
ip = '<自動取得>'
port = recruit['access']['port'] || ''
battle_num = recruit['battle_num'].to_s || ''
weather = recruit['weather'] || ''
character = recruit['character'] || ''
etc = recruit['etc'] || ''
template = recruit['template'] || ''
sim_app1 = recruit['sim_app1']
sim_app2 = recruit['sim_app2']
sim_app3 = recruit['sim_app3']

# メソッド定義
def saveRecruitClick(recruit_file, entry)
  recruit = Hash.new
  recruit['access'] = Hash.new
  recruit['access']['ip'] = entry['ip'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['access']['port'] = entry['port'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['battle_num'] = entry['battle_num'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['weather'] = entry['weather'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['character'] = entry['character'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['etc'] = entry['etc'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['template'] = entry['template'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['sim_app1'] = entry['sim_app1'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['sim_app2'] = entry['sim_app2'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  recruit['sim_app3'] = entry['sim_app3'].value.kconv(Kconv::UTF8, Kconv::SJIS)
  File.open(recruit_file, 'w') do |f|
    f.puts recruit.to_yaml
  end
end

def getFilePath( type, entry )
  if type == '.exe'
    explanation = '実行ファイル'
  elsif type == '.txt'
    explanation = '文書ファイル'
  else
    explanation = 'すべてのファイル'
  end
  filePath = Tk.getOpenFile(:filetypes=>[[explanation.kconv(Kconv::SJIS, Kconv::UTF8), type]])
  entry.set( filePath ) if filePath != ''
end

def startApp( entry )
  Thread.start {
    system(entry.value)
  }
end

def editText( entry )
  Thread.start {
    system('notepad ' + entry.value)
  }
end

# ウィンドウ出力
entry = Hash.new
frame = Hash.new
#fMain = TkFrame.new.pack('side'=>'top')
#fLabel = TkFrame.new(fMain).pack('side'=>'left')
#fEntry = TkFrame.new(fMain).pack('side'=>'left')
#fEdit = TkFrame.new(fMain).pack('side'=>'left')

frame['access'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['access'], :text => '【IP:Port】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['ip'] = TkEntry.new(frame['access'], :width=>13).pack('side'=>'left')
entry['ip'].set(ip.kconv(Kconv::SJIS, Kconv::UTF8))
TkLabel.new(frame['access'], :text => ':').pack('side'=>'left')
entry['port'] = TkEntry.new(frame['access'], :width=>5).pack('side'=>'left')
entry['port'].set(port)
TkLabel.new(frame['access'], :text => '', :width=>9).pack('side'=>'left')

frame['battle_num'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['battle_num'], :text => '【希望対戦回数】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['battle_num'] = TkEntry.new(frame['battle_num']).pack('side'=>'left')
entry['battle_num'].set(battle_num.kconv(Kconv::SJIS, Kconv::UTF8))
TkLabel.new(frame['battle_num'], :text => '', :width=>9).pack('side'=>'left')

frame['weather'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['weather'], :text => '【天候】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['weather'] = TkEntry.new(frame['weather']).pack('side'=>'left')
entry['weather'].set(weather.kconv(Kconv::SJIS, Kconv::UTF8))
TkLabel.new(frame['weather'], :text => '', :width=>9).pack('side'=>'left')

frame['character'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['character'], :text => '【使用キャラ】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['character'] = TkEntry.new(frame['character']).pack('side'=>'left')
entry['character'].set(character.kconv(Kconv::SJIS, Kconv::UTF8))
TkLabel.new(frame['character'], :text => '', :width=>9).pack('side'=>'left')

frame['etc'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['etc'], :text => '【その他コメント】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['etc'] = TkEntry.new(frame['etc']).pack('side'=>'left')
entry['etc'].set(etc.kconv(Kconv::SJIS, Kconv::UTF8))
TkLabel.new(frame['etc'], :text => '', :width=>9).pack('side'=>'left')

frame['template'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['template'], :text => '【募集文の形式】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['template'] = TkEntry.new(frame['template']).pack('side'=>'left')
entry['template'].set(template.kconv(Kconv::SJIS, Kconv::UTF8))
TkButton.new(frame['template'], 'text'=>'参照'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ getFilePath('.txt', entry['template']) }).pack('side'=>'left')
TkButton.new(frame['template'], 'text'=>'編集'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ editText(entry['template']) }).pack('side'=>'left')

frame['sim_app1'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['sim_app1'], :text => '【同時起動アプリ１】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['sim_app1'] = TkEntry.new(frame['sim_app1']).pack('side'=>'left')
entry['sim_app1'].set(sim_app1.kconv(Kconv::SJIS, Kconv::UTF8))
TkButton.new(frame['sim_app1'], 'text'=>'参照'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ getFilePath('.exe', entry['sim_app1']) }).pack('side'=>'left')
TkButton.new(frame['sim_app1'], 'text'=>'起動'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ startApp(entry['sim_app1']) }).pack('side'=>'left')

frame['sim_app2'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['sim_app2'], :text => '【同時起動アプリ２】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['sim_app2'] = TkEntry.new(frame['sim_app2']).pack('side'=>'left')
entry['sim_app2'].set(sim_app2.kconv(Kconv::SJIS, Kconv::UTF8))
TkButton.new(frame['sim_app2'], 'text'=>'参照'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ getFilePath('.exe', entry['sim_app2']) }).pack('side'=>'left')
TkButton.new(frame['sim_app2'], 'text'=>'起動'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ startApp(entry['sim_app2']) }).pack('side'=>'left')

frame['sim_app3'] = TkFrame.new.pack('side'=>'top')
TkLabel.new(frame['sim_app3'], :text => '【同時起動アプリ３】'.kconv(Kconv::SJIS, Kconv::UTF8), :width=>20).pack('side'=>'left')
entry['sim_app3'] = TkEntry.new(frame['sim_app3']).pack('side'=>'left')
entry['sim_app3'].set(sim_app3.kconv(Kconv::SJIS, Kconv::UTF8))
TkButton.new(frame['sim_app3'], 'text'=>'参照'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ getFilePath('.*', entry['sim_app3']) }).pack('side'=>'left')
TkButton.new(frame['sim_app3'], 'text'=>'起動'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ startApp(entry['sim_app3']) }).pack('side'=>'left')

TkLabel.new(:text => '').pack('side'=>'top')

fSave = TkFrame.new.pack('side'=>'top')
TkButton.new(fSave, 'text'=>'保存'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ saveRecruitClick(recruit_file, entry) }).pack('side'=>'left')
TkButton.new(fSave, 'text'=>'終了'.kconv(Kconv::SJIS, Kconv::UTF8), 'command'=>proc{ exit }).pack('side'=>'left')

exit if defined?(REQUIRE2LIB)
Tk.mainloop
